# CheckConstructor.py
# cs 1110 profs
# April 2016
""" Checks that the class definition of Play is correct."""

# You are free to modify this file however you want, since
# you won't be submitting it.

from ThePlayClass  import *


def test_macbeth():
    """Non-exhaustive check that the required attributes
    for MACBETH have reasonable properties.
    Runs some assertion tests, and prints reassuring message
    if all pass."""
    the_scottish_play = Play('MACBETH') # a feeble joke
    tsp = the_scottish_play # shorter to type

    assert tsp.theTitle == 'MACBETH', \
        'Constructor gives incorrect theTitle: ' + tsp.theTitle

    assert tsp.nLines == 2177, \
        ('Constructor error for nLines because '
         + 'wrong number of lines: ' + str(tsp.nLines))
    assert len(vars(tsp)) == 4, \
        'Constructor gives incorrect number of attributes: ' + str(len(vars(tsp)))
    assert type(tsp) is Play, \
        'Constructor not creating a Play but a: ' + str(type(tsp))
    assert type(tsp.theSpeeches) is list, \
        'Constructor makes theSpeeches the wrong type: ' + str(type(tsp.theSpeeches))
    assert type(tsp.theScenes) is list, \
        'Constructor makes theScenes the wrong type: ' + str(type(tsp.theScenes))

    num_speeches = 649
    assert len(tsp.theSpeeches) == num_speeches, \
        ('Constructor error for theSpeeches because '
         + 'wrong number of speeches: ' + str(len(tsp.theSpeeches)))
    for i in range(num_speeches):
        speech = tsp.theSpeeches[i]
        assert type(speech) is Speech, \
            ('Constructor makes item ' + str(i)
                + ' of theSpeeches the wrong type: ' + str(type(speech)))
    speech0 = tsp.theSpeeches[0]
    assert speech0.theSpeaker == 'First Witch', \
        'Constructor gives wrong speaker for speech 0: ' + str(speech0.theSpeaker)
    line0 = speech0.lines[0].strip() # strip because of line endings
    assert line0 == 'When shall we three meet again', \
        'Constructor gives bad line 0 for speech 0: ' + line0

    num_scenes = 28
    assert len(tsp.theScenes) == num_scenes, \
        ('Constructor error for theScenes because '
         + 'wrong number of scenes: ' + str(len(tsp.theScenes)))
    for i in range(num_scenes):
        scene = tsp.theScenes[i]
        assert type(scene) is Scene, \
            ('Constructor makes item ' + str(i)
                + ' of theScenes the wrong type: ' + str(type(scene)))
    scene0 = tsp.theScenes[0]
    assert (scene0.actNumber == 1 and scene0.sceneNumber == 1
            and scene0.location.strip() == 'A desert place'), \
        ('Constructor does something wrong on Scene 0. ' +
            'actNumber is: ' + str(scene0.actNumber) +
            '; sceneNumber is: ' + str(scene0.sceneNumber) +
            '; location is: ' + scene0.location)

    print 'Constructor test test_macbeth assertions passed'


def main():
    """First check that the constructor passes some rough checks
    for MACBETH.
    Then, print and check the number of lines in the tragedies"""
    test_macbeth()

    # dictionary of expected line counts
    num_text_line = {'ANTONY AND CLEOPATRA':3347,
                     'CORIOLANUS': 3585,
                     'HAMLET': 3607,
                     'JULIUS CAESAR': 2436,
                     'KING LEAR': 3267,
                     'MACBETH': 2177,
                     'OTHELLO': 3388,
                     'ROMEO AND JULIET': 2847,
                     'TIMON OF ATHENS': 2305,
                     'TITUS ANDRONICUS': 2344}

    for p in theTragedies():
        P = Play(p)
        assert P.nLines == num_text_line[P.theTitle], \
            'Wrong number of lines for ' + P.theTitle \
            + ': ' + str(P.nLines)
        print P.nLines, p

# BEGIN REMOVE
    # for grading: data for all the other plays
    num_text_line =    {'ALLS WELL THAT ENDS WELL':2820,
                        'AS YOU LIKE IT':2616,
                        'COMEDY OF ERRORS':1765,
                        'CYMBELINE':3402,
                        'LOVES LABOUR LOST':2645,
                        'MEASURE FOR MEASURE':2640,
                        'MERCHANT OF VENICE':2535,
                        'MERRY WIVES OF WINDSOR':2464,
                        'MIDSUMMERS NIGHTS DREAM':2067,
                        'MUCH ADO ABOUT NOTHING':2514,
                        'PERICLES':2209,
                        'TAMING OF THE SHREW':2480,
                        'TEMPEST':2077,
                        'TROILUS AND CRESSIDA':3353,
                        'TWELFTH NIGHT':2354,
                        'TWO GENTLEMAN OF VERONA':2147,
                        'WINTERS TALE':3174,
                        'HENRY IV PART 1':2944,
                        'HENRY IV PART 2':2955,
                        'HENRY V':3070,
                        'HENRY VI PART 1':2586,
                        'HENRY VI PART 2':2995,
                        'HENRY VI PART 3':2808,
                        'HENRY VIII':3106,
                        'KING JOHN':2545,
                        'RICHARD II':2633,
                        'RICHARD III':3396}
    for p in theComedies() + theHistories():
        P = Play(p)
        assert P.nLines == num_text_line[P.theTitle], \
            'Wrong number of lines for ' + P.theTitle \
            + ': ' + str(P.nLines)
# END REMOVE

if __name__ == '__main__':

    main()
