# ThePlayClass.py
# PUT YOUR NAME(S) AND NETID(S) HERE
# Skeleton by the CS 1110 profs, April 2016
# PUT DATE COMPLETED HERE

from PlayTools import *
from GetData import *

class Play(object):
    """
    attributes:
        theTitle        the name of the play [str]
        theSpeeches     a list of all the speeches in the play [list(Speech)]
        theScenes       a list of all the scenes in the play [list(Scene)]
        nLines          the total number of lines in the play [int]
    """

    def __init__(self, p):
        """Returns a reference to a Play object.
        PreC: p is an all-caps string that names a Shakespearean play in
        directory ThePlays. (No suffixes, e.g., 'HAMLET', not 'HAMLET.txt'.)
        The folder ThePlays must be in the current working directory.
        """
        pass
# BEGIN REMOVE
        self.theTitle=p
        self.theSpeeches = ListOfSpeeches(p)
        self.theScenes = ListOfScenes(p)
        # Number of Lines...
        nLines = 0
        for speech in self.theSpeeches:
            nLines += len(speech.lines)
        self.nLines = nLines
# END REMOVE


    def MajorParts(self):
        """ Returns an alphabetized list of strings that
        name all the major characters in this Play.
        """
        pass
# BEGIN REMOVE
        L = []
        for x in self.theSpeeches:
            s = x.theSpeaker
            if s == s.upper() and s not in L:
                L.append(s)
        L.sort()
        return L
# END REMOVE


    def Freq(self,w):
        """ Returns an int that is the number of times that w (as a word on its own)
        occurs in this Play. (So, if w is "th", "the" doesn't add to its count.)

        PreC: w is a string.
        """
        pass
# BEGIN REMOVE
        n = 0
        for s in self.theSpeeches:
            # s is a list of speeches
            for x in s.lines:
                # x is a line from speech s
                wordList = stringToWordList(x)
                # add in the number of times w is a word in x
                n += wordList.count(w)
        return n
# END REMOVE


    def SpeakersAndLines(self):
        """ Returns a dictionary whose keys are speakers and whose
        values are the total number of lines that the speaker has
        in this Play."""
        pass
# BEGIN REMOVE
        D = {}
        for x in self.theSpeeches:
            s = x.theSpeaker
            if s in D:
                D[s] += len(x.lines)
            else:
                D[s] = len(x.lines)
        return D
# END REMOVE


# BEGIN REMOVE
# Slight variant implementation
    def SpeakersAndLines2(self):
        """ Same spec as SpeakersAndLines. """
        D = {}
        for speech in self.theSpeeches:
            speaker = speech.theSpeaker
            if speaker not in D:
                D[speaker] = 0 # initialize
            D[speaker] += speech.nLines
        return D
# END REMOVE


